Subject: Re: [ldapext] Re: draft-ietf-boreham-numsubordinates-01.txt

From: "Jim Sermersheim" <[email-masked]>
Date: Tue, 28 Oct 2003 08:21:14 -0700

Right, when people on this thread are talking about subentries, they are talking about subentries in the X.500 subentry sense of the word (like subschema subentry, prescriptiveACI subentry, etc).

Jim

>>> Michael Ströder <[email-masked]> 10/28/03 1:25:01 AM >>>
Ludovic Poitou wrote:
> 
> Michael Ströder wrote:
> 
>> Ludovic Poitou wrote:
>> >
>> > John McMeeking wrote:
>> >>
>> >>> Firstly I'm curious as to what `numSubordinates' identifies as 
>> being a
>> >>> subordinate?
>> >>> Eg. Is a subentry counted as a subordinate?
>> >> I'd vote for including subentries.
>>
>>> I'd vote for including subentries as well...
>>
>> Any use-cases for including subentries?
>> Which are the use-cases for 'numSubordinates'?
> 
> The question was whether SubEntries should be counted in the 
> numSubordinate operational attribute.

This question simply can't be answered without looking at possible use-cases 
for this attribute.

> If subentries are counted in the numSubordinate attribute, 
> an entry that has subEntries will have a positive numSubordinate but 
> regular client applications won't see any child entries. Some apps may 
> be confused by this behavior, but this can already happen with ACI.

Yes, this is the same issue like any scenario with ACI/ACLs in effect.

> As opposed, not counting SubEntries in the numSubordinate attribute, an 
> application can read the numSubordiante attribute, see its value is 0, 
> delete the entry and get a NON_LEAF error... and be confused....

IMHO

entry is leaf entry
<=> value of hasSubordinates is 'FALSE'
<=> value of numSubordinates is '0'

no matter whether you count all sub entries or just the next level.

Examples (please correct me if I got it wrong):

1. Counting all sub entries in numSubordinates:

dc=test,dc=com (numSubordinates: 5)
|
+-ou=Test1 (numSubordinates: 0)
|
+-ou=Test2 (numSubordinates: 3)
|
+-cn=Testperson1 (numSubordinates: 0)
|
+-cn=Testperson2 (numSubordinates: 1)
|
+-mail=[email-masked] (numSubordinates: 0)

2. Counting only one-level in numSubordinates (similar to what's another 
vendor is doing in an attribute called 'subordinateCount'):

dc=test,dc=com (numSubordinates: 2)
|
+-ou=Test1 (numSubordinates: 0)
|
+-ou=Test2 (numSubordinates: 2)
|
+-cn=Testperson1 (numSubordinates: 0)
|
+-cn=Testperson2 (numSubordinates: 1)
|
+-mail=[email-masked] (numSubordinates: 0)

As you can see in any scenario leaf-entries have numSubordinates set to zero.

Hmm, maybe I don't understand the word "SubEntries" correctly?
Maybe you are talking about sub entries like sub schema sub entry?

Ciao, Michael.

_______________________________________________
Ldapext mailing list
[email-masked] 
https://www1.ietf.org/mailman/listinfo/ldapext